%% Functions over booleans and lists,
%% for including in your own signatures.

-module(stdsigs).
-include_lib("eqc/include/eqc.hrl").
-compile(export_all).

bool_vars() ->
    [{[x, y, z], bool}].

bool_funs() ->
    [{fun() -> true end, true, [], bool},
     {fun() -> false end, false, [], bool},
     {fun(X) -> not X end, 'not', [bool], bool},
     {fun(X, Y) -> X and Y end, '&&', [bool, bool], bool},
     {fun(X, Y) -> X or Y end, '||', [bool, bool], bool}].

list_vars(List) ->
    [{[xs, ys, zs], List}].

list_funs(Elem, List) ->
    [{fun() -> [] end, '[]', [], list},
     {fun(X, Xs) -> [X|Xs] end, '|', [Elem, List], List},
     {erlang, '++', [List, List], List},
     {fun([]) -> true;
         (_) -> false end, null, [List], bool},
     {lists, reverse, [List], List},
     {erlang, hd, [List], Elem},
     {erlang, tl, [List], List}].
