%% gb_trees---maps from keys to values.
%%
%% There are two functions, enter and insert, for inserting entries
%% into a tree.
%% Try running
%%   laws:laws(trees_sig, [enter, insert])
%% and see if you can spot the difference between enter and insert.
%% 
%% (Hint: look for laws about a key being inserted twice.)

-module(trees_sig).
-include_lib("eqc/include/eqc.hrl").
-compile(export_all).

var_types() ->
    [{[i, j, k], key},
     {[x, y, z], value},
     {[t, u, v], tree},
     {[xs, ys, zs], list}].

fun_types() ->
    [{gb_trees, balance, [tree], tree},
     {gb_trees, delete, [key, tree], tree},
     {gb_trees, delete_any, [key, tree], tree},
     {gb_trees, empty, [], tree},
     {gb_trees, enter, [key, value, tree], tree},
     {gb_trees, from_orddict, [list], tree},
     {gb_trees, get, [key, tree], value},
     {gb_trees, insert, [key, value, tree], tree},
     {gb_trees, to_list, [tree], list}].

observe(Tree, tree) ->
    gb_trees:to_list(Tree).

key() ->
    int().

value() ->
    int().

%% Generate an ordered list of {key, value} pairs.
list() ->
    ?LET(Xs, list({key(), value()}),
         orddict:from_list(Xs)).

%% Generate a tree by starting from a list of {key, value} pairs.
tree() ->
    ?LET(Xs, list(),
         gb_trees:from_orddict(Xs)).
